function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { IconFont } from '@zgfe/business-lib';
import { Input, Table } from 'antd';
import React, { useEffect, useState } from 'react';
import ZModulesCDP from '../../../../../types';
import { ColumnCell } from '../compareTable';
import { columnNameReg } from '../row2Column/columnName';
var Preview = function Preview(_ref) {
  var defaultValue = _ref.defaultValue,
    list = _ref.list,
    selected = _ref.selected,
    onChange = _ref.onChange;
  var _useState = useState([]),
    _useState2 = _slicedToArray(_useState, 2),
    columnList = _useState2[0],
    setColumnList = _useState2[1];
  var _useState3 = useState(''),
    _useState4 = _slicedToArray(_useState3, 2),
    columnName = _useState4[0],
    setColumnName = _useState4[1];
  var _useState5 = useState(''),
    _useState6 = _slicedToArray(_useState5, 2),
    columnValue = _useState6[0],
    setColumnValue = _useState6[1];
  useEffect(function () {
    if (!defaultValue) return;
    setColumnName(defaultValue.columnName);
    setColumnValue(defaultValue.columnValue);
  }, []);
  useEffect(function () {
    var nameList = selected.map(function (item) {
      return item.name;
    });
    var res = list.filter(function (item) {
      return !nameList.includes(item.name);
    });
    if (!nameList.length) {
      setColumnList([]);
    } else {
      setColumnList([{
        name: '__fix__column_name',
        comment: '',
        webType: ZModulesCDP.WebType.string,
        isPrimaryKey: false,
        type: ''
      }, {
        name: '__fix__column_value',
        comment: '',
        webType: ZModulesCDP.WebType.string,
        isPrimaryKey: false,
        type: ''
      }].concat(_toConsumableArray(res)));
    }
  }, [list, selected]);
  useEffect(function () {
    if (onChange) onChange({
      columnName: columnName,
      columnValue: columnValue
    });
  }, [columnName, columnValue]);
  return /*#__PURE__*/React.createElement(Table, {
    columns: [{
      title: '字段名称',
      dataIndex: 'name',
      render: function render(v, row) {
        if (v === '__fix__column_name') {
          return /*#__PURE__*/React.createElement(Input, {
            value: columnName,
            placeholder: "\u8BF7\u8F93\u5165\u5217\u540D\uFF08\u539F\u5B57\u6BB5\uFF09",
            addonAfter: /*#__PURE__*/React.createElement(IconFont, {
              type: "bianji"
            }),
            onChange: function onChange(e) {
              e.persist();
              if (!columnNameReg.test(e.target.value) || /\^/.test(e.target.value)) return;
              setColumnName(e.target.value);
            }
          });
        } else if (v === '__fix__column_value') {
          return /*#__PURE__*/React.createElement(Input, {
            value: columnValue,
            placeholder: "\u8BF7\u8F93\u5165\u5217\u540D\uFF08\u539F\u503C\uFF09",
            addonAfter: /*#__PURE__*/React.createElement(IconFont, {
              type: "bianji"
            }),
            onChange: function onChange(e) {
              e.persist();
              if (!columnNameReg.test(e.target.value) || /\^/.test(e.target.value)) return;
              setColumnValue(e.target.value);
            }
          });
        }
        return /*#__PURE__*/React.createElement(ColumnCell, {
          column: row
        });
      }
    }],
    rowKey: "name",
    dataSource: columnList,
    pagination: false
  });
};
export default Preview;